#include <DxLib.h>

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow) {
	// gpx
	(void)hInstance;(void)hPrevInstance;(void)lpCmdLine;(void)nCmdShow; 

	// DXCu
	if(ChangeWindowMode(TRUE)!=DX_CHANGESCREEN_OK || DxLib_Init()==-1) return -1;
	SetDrawScreen(DX_SCREEN_BACK);

	// 
	enum Status {
		STATUS_INIT,
		STATUS_INPUT,
		STATUS_RESULT
	} stat = STATUS_INIT;

	// L[
	const int KeyMax = 356;
	char Key[KeyMax];
	char KeyEdge[KeyMax];
	char PrevKey[KeyMax]={};

	// 񂯂̎̎ސ
	const int JANKEN_HAND_NUM = 3;
	// 񂯂̎
	const int JANKEN_ROCK = 0;
	const int JANKEN_SCISSOR = 1;
	const int JANKEN_PAPER = 2;
	const int JANKEN_HAND_DATA[JANKEN_HAND_NUM] = {
		JANKEN_ROCK, JANKEN_SCISSOR, JANKEN_PAPER
	};
	const char* JANKEN_HAND_TEXT[JANKEN_HAND_NUM] = {
		"O[", "`L", "p["
	};
	const int JANKEN_HAND_KEY[JANKEN_HAND_NUM] = {
		KEY_INPUT_1, KEY_INPUT_2, KEY_INPUT_3
	};
	// 񂯂̏s
	const int JANKEN_WIN = 0;
	const int JANKEN_DRAW = 1;
	const int JANKEN_LOSE = 2;
	const char* JANKEN_JUDGE_TEXT[JANKEN_HAND_NUM] = {
		"Ȃ̏łI", "łB", "Ȃ̕łEEE"
	};
	// [][ɑ΂]s
	const int JANKEN_JUDGE[JANKEN_HAND_NUM][JANKEN_HAND_NUM] = {
		{JANKEN_DRAW, JANKEN_WIN, JANKEN_LOSE},
		{JANKEN_LOSE, JANKEN_DRAW, JANKEN_WIN},
		{JANKEN_WIN, JANKEN_LOSE, JANKEN_DRAW}
	};
	// o
	int myHand = 0;
	int cpuHand = 0;

	bool endFlag = false;
	while(!endFlag && !ProcessMessage() && !ClearDrawScreen() && !GetHitKeyStateAll(Key)) {
		// L[
		for(int i=0;i<KeyMax;i++)KeyEdge[i]=Key[i]&&(!PrevKey[i]);
		for(int i=0;i<KeyMax;i++)PrevKey[i]=Key[i];

		// Ԃɉĕ
		switch(stat) {
			case STATUS_INIT:
				cpuHand = JANKEN_HAND_DATA[GetRand(2)];
				stat = STATUS_INPUT;
				break;
			case STATUS_INPUT:
				DrawString(0,  0, "uWP!v", GetColor(255,255,255));
				DrawString(0, 20, "Ȃ̎͂ĉ(O[:1 `L:2 p[:3)", GetColor(255,255,255));
				for (int i = 0; i < JANKEN_HAND_NUM; i++) {
					if(KeyEdge[JANKEN_HAND_KEY[i]]) {
						myHand = JANKEN_HAND_DATA[i];
						stat = STATUS_RESULT;
						break;
					}
				}
				break;
			case STATUS_RESULT:
				DrawString(0, 40, "u|!v", GetColor(255,255,255));
				DrawFormatString(0, 60, GetColor(255,255,255),"Ȃ:%s", JANKEN_HAND_TEXT[myHand]);
				DrawFormatString(0, 80, GetColor(255,255,255),":%s", JANKEN_HAND_TEXT[cpuHand]);
				DrawFormatString(0, 100, GetColor(255, 255,255),":%s",
					JANKEN_JUDGE_TEXT[JANKEN_JUDGE[myHand][cpuHand]]);
				DrawString(0, 120, "ESCL[ŏI܂B", GetColor(255, 255, 0));
				if(KeyEdge[KEY_INPUT_ESCAPE]) {
					endFlag = true;
				}
				break;
		}

		ScreenFlip();
	}

	DxLib_End();
	return 0;
}
